package com.warewms.common.utils;

import com.warewms.common.exception.RRException;
import io.swagger.models.auth.In;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.lang.StringUtils;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.lang.reflect.Field;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by IntelliJ IDEA.
 * User: andy.qu
 * Date: 2019/11/14
 */
public class CommonUtils {

    /**
     * 文件下载
     *
     * @param file
     * @param res
     * @throws IOException
     */
    public static void download(File file, HttpServletResponse res) throws IOException {
        // 发送给客户端的数据
        OutputStream outputStream = res.getOutputStream();
        byte[] buff = new byte[1024];
        BufferedInputStream bis = null;
        // 读取filename
        bis = new BufferedInputStream(new FileInputStream(file));
        int i = bis.read(buff);
        while (i != -1) {
            outputStream.write(buff, 0, buff.length);
            outputStream.flush();
            i = bis.read(buff);
        }
    }

    /**
     * 文件下载
     *
     * @param inputStream
     * @param res
     * @throws IOException
     */
    public static void download(InputStream inputStream, HttpServletResponse res) throws IOException {
        // 发送给客户端的数据
        OutputStream outputStream = res.getOutputStream();
        byte[] buff = new byte[1024];
        BufferedInputStream bis = null;
        // 读取filename
        bis = new BufferedInputStream(inputStream);
        int i = bis.read(buff);
        while (i != -1) {
            outputStream.write(buff, 0, buff.length);
            outputStream.flush();
            i = bis.read(buff);
        }
    }

    /**
     * 对象字符串转换null判断
     *
     * @return
     */
    public static String objectStringConvert(Object object) {
        return object == null ? "" : object.toString();
    }

    /**
     * 检查是否为Int
     * @param value 值
     * @param fildName 提示字段名称
     * @return
     */
    public static void checkInt(String value,String fildName){
        try{
            Integer i = Integer.parseInt(value);
        }catch (Exception e){
            throw new RRException(fildName+"必须是整数");
        }
    }

    public static final String addZero(int current, int length) {
        String s = current + "";
        while (s.length() < length) {
            s = "0" + s;
        }
        return s;
    }

    public static final String addZeroString(String current, int length) {
        String s = current;
        while (s.length() < length) {
            s = "0" + s;
        }
        return s;
    }

    public static void main(String[] args) {

        System.out.println(String.format("%04X",Integer.parseInt("0001")));

    }


}
