package com.warewms.entity;

import com.warewms.enums.ResultEnum;
import com.warewms.utils.CommonUtils;
import org.apache.http.HttpStatus;

import java.util.HashMap;
import java.util.Map;

/**
 * 返回数据
 * 
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2016年10月27日 下午9:59:27
 */
public class R extends HashMap<String, Object> {
	private static final long serialVersionUID = 1L;
	
	public R() {
		put("code", 0);
		put("msg", "success");
	}
	
	public static R error() {
		return error(HttpStatus.SC_INTERNAL_SERVER_ERROR, "未知异常，请联系管理员");
	}
	
	public static R error(String msg) {
		return error(HttpStatus.SC_INTERNAL_SERVER_ERROR, msg);
	}

	public static R error(String msg, Object object) {
		R r = new R();
		r.put("code", 500);
		r.put("msg", msg);
		r.put("data",object);
		return r;
	}
	
	public static R error(int code, String msg) {
		R r = new R();
		r.put("code", code);
		r.put("msg", msg);
		r.put("data",null);
		return r;
	}

	public boolean isOk() {

	    return get("code").equals(0);
    }

	public static R ok(String msg) {
		R r = new R();
		r.put("msg", msg);
		r.put("data",null);
		return r;
	}

	public static R ok(String msg, Object object) {
		R r = new R();
		r.put("code", 0);
		r.put("msg", msg);
		r.put("data",object);
		return r;
	}
	
	public static R ok(Map<String, Object> map) {
		R r = new R();
		r.putAll(map);
		return r;
	}
	
	public static R ok() {
		return new R();
	}

	public R put(String key, Object value) {
		super.put(key, value);
		return this;
	}

	public String getMsg() {
		return CommonUtils.objectStringConvert(super.get("msg"));
	}

	public static R error(ResultEnum resultEnum){
		return error(resultEnum.getCode(), resultEnum.getMessage());
	}
}
