package com.warewms.service.impl;

import com.alibaba.fastjson.JSON;
import com.jfinal.kit.Kv;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.jfinal.plugin.activerecord.SqlPara;
import com.warewms.common.annotation.JFinalTx;
import com.warewms.common.utils.RecordUtils;
import com.warewms.entity.erp.*;
import com.warewms.service.ErpSyncService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
public class ErpSyncServiceImpl implements ErpSyncService {

    @Autowired
    private StringRedisTemplate redisTemplate;

    @JFinalTx
    @Override
    public void erpSync() {
        //skuType
        /*SqlPara sqlPara = Db.getSqlPara("erp.selectProType");
        List<Record> recordList = Db.find(sqlPara);
        if (recordList != null && recordList.size() > 0) {
            List<ErpProType> list = new ArrayList<>();
            for (Record record : recordList) {
                ErpProType proType = new ErpProType();
                proType.setTypeId(record.getStr("P_TYPE_ID"));
                proType.setTypeDesc(record.getStr("P_TYPE_DESC"));
                list.add(proType);

                Kv param = Kv.create();
                param.put("typeId", proType.getTypeId());
                SqlPara update = Db.getSqlPara("erp.updateProType", param);
                Db.update(update);
            }
            redisTemplate.opsForValue().set("erpProType", JSON.toJSONString(list));
        }

        SqlPara sqlParaOb = Db.getSqlPara("erp.selectProOb");
        List<Record> recordObList = Db.find(sqlParaOb);
        List<ErpProOb> erpProObList = RecordUtils.converModel(recordObList, ErpProOb.class);
        if (erpProObList != null && erpProObList.size() > 0) {
            for (ErpProOb erpProOb : erpProObList) {
                Kv param = Kv.create();
                param.put("ima01", erpProOb.getIma01());
                SqlPara update = Db.getSqlPara("erp.updateProOb", param);
                Db.update(update);
            }
            redisTemplate.opsForValue().set("erpProOb", JSON.toJSONString(erpProObList));
        }

        SqlPara sqlParaBarCode = Db.getSqlPara("erp.selectBarCode");
        List<Record> recordBarCodeList = Db.find(sqlParaBarCode);
        List<ErpProBarCode> erpBarCodeList = RecordUtils.converModel(recordBarCodeList, ErpProBarCode.class);
        if (erpBarCodeList != null && erpBarCodeList.size() > 0) {
            for (ErpProBarCode erpProBarCode : erpBarCodeList) {
                Kv param = Kv.create();
                param.put("barcode", erpProBarCode.getBarcode());
                SqlPara update = Db.getSqlPara("erp.updateBarCode", param);
                Db.update(update);
            }
            redisTemplate.opsForValue().set("erpBarCode", JSON.toJSONString(erpBarCodeList));
        }*/

        SqlPara sqlParaOrderList = Db.getSqlPara("erp.selectOrderList");
        List<Record> recordOrderList = Db.find(sqlParaOrderList);
        List<ErpOrderList> erpOrderLists = RecordUtils.converModel(recordOrderList, ErpOrderList.class);
        if (erpOrderLists != null && erpOrderLists.size() > 0) {
            for (ErpOrderList erpOrderList : erpOrderLists) {
                Kv param = Kv.create();
                param.put("orderNo", erpOrderList.getOrderNo());
                param.put("orderName", erpOrderList.getOrderName());
                SqlPara update = Db.getSqlPara("erp.updateOrderList", param);
                Db.update(update);
            }
            redisTemplate.opsForValue().set("erpOrderList", JSON.toJSONString(erpOrderLists));
        }
    }

    @JFinalTx
    @Override
    public void writeBack(List<ErpBarCodeList> erpBarCodeListList) {
        for (ErpBarCodeList erpBarCodeList : erpBarCodeListList) {
            Kv param = Kv.create();
            param.set("barcode",erpBarCodeList.getBarcode());
            param.set("orderName",erpBarCodeList.getOrderName());
            param.set("orderNo",erpBarCodeList.getOrderNo());
            param.set("qty",erpBarCodeList.getQty());
            param.set("orderType",erpBarCodeList.getOrder_type());
            param.set("inout",erpBarCodeList.getInOut());
            param.set("stockID",erpBarCodeList.getStockId());
            param.set("boxid",erpBarCodeList.getBoxNo());
            param.set("createUser", erpBarCodeList.getCreateUser());
            param.set("createDate",erpBarCodeList.getCreateDate());
            param.set("wmsMark","N");
            SqlPara sqlPara = Db.getSqlPara("erp.insertBarcodeList",param);
            Db.update(sqlPara);
        }
    }
}
